/*Rein June 2008
  References:
  [1] S.Rein, "Fixed-Point Arithmetic in C: A Tutorial and an Example on Wavelet Filtering", available at www.mdt.tu-berlin.de/research/wavelets
*/
//change the eponent expA from a to expB
#define ChangeExp(a,expA,expB)\
  (  ((expB)>(expA)) ? (a)<<abs((expB)-(expA)) : (a)>>((expA)-(expB))  )
//put in abs() to avoid a "left shift negative" warning
#define FloatToFix(Bfloat,expB) ((int)( (Bfloat)*(float) (1<<(expB) )  ))

#define FixToFloat(b,expB) ( (float) (b) / (float) (1<<(expB)) )

#define AddFix(a,b) ((a)+(b)) //add two fixed-point number with same exponents
#define SubFix(a,b) ((a)-(b)) //and return a fixed-point number with the input exponent

//add two fixed-point number with eponents expA and expB and return a result with expC
#define AddFixExp(a,b,expA,expB,expC) (ChangeExp(a,expA,expC)+ChangeExp(b,expB,expC))
#define SubFixExp(a,b,expA,expB,expC) (ChangeExp(a,expA,expC)-ChangeExp(b,expB,expC))

#define AddFixInt(a,b,expA) ((a)+((b)<<(expA) ))
#define SubFixInt(a,b,expA) ((a)-((b)<<(expA) ))

#define MulFix(a,b,expC) (((a)*(b))>>(expC)) //multiply two operands with expC and
                                             //return the result with expC
#define MulFixExp(a,b,expA,expB,expC) (ChangeExp((a)*(b),(expA)+(expB),expC))
#define MulFixInt(a,b) ((a)*(b))//multiply a with integer b and return a fp result with expA

#define DivFix(a,b,expC) (((a)<<(expC)/(b))//divide two operands with expC and
                                           //return a result with expC
//divide a with expA through b with expB and return a result with expC:
#define DivFixExp(a,b,expA,expB,expC) ( ChangeExp(a,expA,expB+expC)/b )
#define DivFixInt(a,b) ((a)/(b))// result is given in the format of a

//help fct for ConvAdd of lifting.c
#define update(a,b,c,P,expAB,expC,expP,expResult) (AddFixExp(\
(a+b)*P,\
c,\
expAB+expP,expC,expResult\
))
