//FpInvTransformPic.c
//Rein Mai 2008
#include  <stdio.h> //for printf
#include "TransformPic.h" //transpose fct needed

#include "FpInvTransformPic.h"
#include "TestFixed.h" //filter fcts and coefficients

void FpInvWaveletTransform(INT16 *Mpic,UINT8 level,INT8 ExpFirstLevel){
  //the data to be transformed is in signed INT16 format
  //the reconstructed data is written into the input matrix to 
  //the same data format
  printf("fixed point inv transform\n");
 
  UINT8 undo=1;
  rescale(Mpic,level,ExpFirstLevel-level+1,undo);

  UINT16 Npic=Mpic[0];
  UINT16 N=Npic/Pow(2,level-1);
  INT8 expIn=ExpFirstLevel-level+1;
  
  
  while(N<=Npic){
    transpose(Mpic,N);
    dwrec(Mpic,N,expIn,expIn);
    transpose(Mpic,N);
    dwrec(Mpic,N,expIn,expIn+1);
    N*=2;
    expIn++;
    }
  //scale back to exp=0->divide through 2^(ExpFirstLevel+1):
  rescale(Mpic,1,ExpFirstLevel+1,0);//MaxWaveletLevel,ExpLastLevel,undo=0 
}

void dwrec(INT16 *Mpic,UINT16 N,INT8 expIn,INT8 expOut){
  UINT16 Npic=Mpic[0];
  //printf("dwrec N:%i",N);

  UINT16 i,j;
  INT16 dest_line[N];
  for (i=0;i<N;i++){//do for each line
    for (j=0;j<N;j++){
      dest_line[j] =FiltSynFixL(&Mpic[i*Npic+1],j,N,expIn,expOut);
      dest_line[j]+=FiltSynFixH(&Mpic[i*Npic+N/2+1],j,N,expIn,expOut);
    }
    for (j=0;j<N;j++) Mpic[i*Npic+j+1]=dest_line[j];
  }
}


