//TransformPic.c
//Rein Mai 2008

//#include "../SpisaTerm.h"
#include "FpTransformPic.h"
#include "TestFixed.h" //filter fcts and coefficients

void FpWaveletTransform(INT16* Mpic, UINT8 level,INT8 ExpFirstLevel){ 
  // use int input: command s l "pic.int"
   
  //the matrix is overwritten with the result in the same data format
  UINT16 Npic=Mpic[0];//format "INT16p"
  UINT16 N=Npic;    
  INT8 expIn,expOut;
  //INT8 ExpFirstLevel=5;//data format for the coefficients 
  expOut=ExpFirstLevel;//of the first level wavelet transform
  expIn=0; // data format of the input picture
  while (N>=Npic/Pow(2,level-1)) {
    //printf("N:%i\n",N);
    dwt(Mpic,N,expIn,expOut);
    transpose(Mpic,N);
    dwt(Mpic,N,expOut,expOut);
    transpose(Mpic,N);
    N/=2;
    expIn=expOut;
    expOut--;
  }
  UINT8 undo=0;
  rescale(Mpic,level,ExpFirstLevel-level+1,undo);
}
void dwt(INT16 *Mpic,UINT16 N,INT8 expIn,INT8 expOut){
  UINT16 Npic=Mpic[0];
  //printf("N:%i",N);
          
  
  UINT16 i,j;
  INT16 dest_line[N];
  for (i=0;i<N;i++){//do for each line 
    for (j=0;j<N/2;j++) {
      dest_line[j]=    FiltFixL(&Mpic[i*Npic+1],j*2,N,expIn,expOut);
      dest_line[j+N/2]=FiltFixH(&Mpic[i*Npic+1],j*2+1,N,expIn,expOut);
    } 
    for (j=0;j<N;j++) Mpic[i*Npic+j+1]=dest_line[j];
  }
}
void transpose(INT16* Mpic,UINT16 N){
  UINT16 Npic=Mpic[0];
  //printf("transpose N:%i\n",N);        
  INT16 Mhelp[N*N+1];
  UINT32 rw,cl,i;
  for(rw=0;rw<N;rw++)for(cl=0;cl<N;cl++)
    Mhelp[cl*N+rw+1]=Mpic[rw*Npic+cl+1];
  for(rw=0;rw<N;rw++)for(cl=0;cl<N;cl++)
    Mpic[rw*Npic+cl+1]=Mhelp[rw*N+cl+1];
}
