//InOutPic.c
#include"InOutPic.h"

INT16* ReadPic(char *cmd,int *NoPixels){
  UINT8 len=GetParaLen(cmd); 
  char filename[len+1];strncpy(filename,cmd,len);
  filename[len]=0;//terminate string
  printf("reading file >%s<\n",filename);
  FILE *fp = fopen(filename, "rb");
  if (fp == NULL) {
    fprintf(stderr, "Can't open input file\n");
    exit(1);
  }
  int value;
  //first estimate no of pixels:
  int NoPix=0;
  while (!feof(fp)) {fscanf(fp,"%i ",&value);NoPix++;}
  //printf("no of pixels:%i\n",NoPix);
  rewind(fp);//reset filepointer to start
  INT16* matrix;
  matrix= (INT16 *) malloc ((NoPix+1)*sizeof(INT16));//create picture matrix
  printf("dim=%i\n",Sqrt(NoPix));
 
  matrix[0]=Sqrt(NoPix);//store the dimension N of the pic
  int i;
  for (i=1;i<NoPix+1;i++){
    fscanf(fp,"%i ",&value);
    //printf("value(%i):%i-",i,value);
    matrix[i]=value;
  }
  fclose(fp);
  *NoPixels=NoPix;//return no of pixels
  return matrix;
}
 
void WritePic(char *cmd,INT16* matrix,int NoPixels){
  UINT8 len=GetParaLen(cmd); 
 
  char filename[len+1];
  strncpy(filename,cmd,len);
  filename[len]=0;//terminate string
  printf("writing file >%s<\n",filename);
  FILE *fp = fopen(filename, "w");
  int i; 
  for (i=1;i<NoPixels+1;i++){
    fprintf(fp,"%i ",matrix[i]);
  }  
  fclose(fp);
}

FILE*  InitWriteBit(char *fnP){
  //either opens a file stream and stores the file pointer or
  //returns the file pointer
  static FILE *fp;// file pointer
  if (fnP!=NULL) { //init
    UINT8 len=GetParaLen(fnP);
    char filename[len+1];
    strncpy(filename,fnP,len);
    filename[len]=0;//terminate string
    printf("writing file >%s<\n",filename);
    fp = fopen(filename,"w");
  }
  return fp;//return file pointer with InitWriteBit(NULL);
}

void   WriteBit(INT8 bit) {
  static INT8 NoBits=0;// no of bits in the current byte
  static int NoBytes=0;// total no of bytes excluding the single bits 
  static INT8 byte=0;// bits are written to this byte 
  FILE *fp=InitWriteBit(NULL);// get the file pointer
  if ((bit==0)||(bit==1)) {// add the "bit" to the "byte"
    UINT8 mask=128>>NoBits;//128 means that the most left bit is one  
    //printf("%i:",bit);
    if (bit) byte=byte|mask;// bits are written from left to right
    NoBits++; 
    if (NoBits==8) {
      fwrite(&byte,sizeof(byte),1,fp); 
      //printf(" ");
      NoBits=0;NoBytes++;byte=0;
    }
  }
  else if (bit==3){// close the stream and signal no of bits in last byte
    if (NoBits>0) {
      fwrite(&byte,sizeof(byte),1,fp);// write incompl byte
      NoBytes++;//the total byte no.to be displayed also includes the incompl.byte
    }
    else NoBits=8;// NoBits was =0 -> the last byte has 8 bits
    fwrite(&NoBits,sizeof(NoBits),1,fp);// signal no. of bits within last byte
    fclose(fp);
    printf("Stream Closed! NoBytes:%i, NoBits in last byte:%i\n",NoBytes,NoBits);
    NoBits=0;NoBytes=0;byte=0;
  }
}


FILE*  InitReadBit(char *fnP) {
  //a)init: open file stream and store file pointer 
  //  with InitReadBit(<filename>)
  //b) just return the file pointer with InitReadBit(NULL)
  static FILE *fp;// file pointer
  if (fnP!=NULL) { //a) init
    UINT8 len=GetParaLen(fnP);
    char filename[len+1];
    strncpy(filename,fnP,len);
    filename[len]=0;//terminate string
    printf("reading from bin file >%s<\n",filename);
    fp = fopen(filename,"r");
  }
  //b)
  return fp;//return file pointer with InitReadBit(NULL);
}
FILE*  InitReadBit2(char *fnP) {
  //a)init: open file stream and store file pointer 
  //  with InitReadBit(<filename>)
  //b) just return the file pointer with InitReadBit(NULL)
  static FILE *fp;// file pointer
  if (fnP!=NULL) { //a) init
    UINT8 len=GetParaLen(fnP);
    char filename[len+1];
    strncpy(filename,fnP,len);
    filename[len]=0;//terminate string
    printf("reading from bin file >%s<\n",filename);
    fp = fopen(filename,"r");
  }
  //b)
  return fp;//return file pointer with InitReadBit(NULL);
}



INT8 ReadBit() {// file is read in the reversed order !
  static int NoBytes;// no of bytes left to read  
  static INT8 NoBits;// no of bits left to read
  static INT8 byte;// bits are read from this byte 
  INT8 ReadIncomplete=0;// signals if the last incomplete byte
  //should be read
  static FILE *fp=NULL;
  if (fp==NULL) {// init: get no. of bytes/bits
    fp=InitReadBit(NULL);// get the file pointer
    while (1) {// estimate total no of bytes in the file
      fread(&byte,sizeof(byte),1,fp);//traverse all bytes
      if (feof(fp)) break;//until the last byte
      NoBytes++;//finally also includes signaling byte
    } 
    NoBytes-=1;// subtract last (non-binary) signaling byte
    NoBits=byte;//get the NoBits from the (last) signaling byte
    printf("ReadBit():NoBytes:%i NoBits in last byte:%i\n",NoBytes,NoBits);
    //exit(0);
    if (NoBits!=8) ReadIncomplete=1;//the last bin byte is incomplete
  } // end of init
  if ((NoBits==8)||ReadIncomplete) {// read a new byte:
    //printf(" ");
    fseek(fp,NoBytes-1,0);// 0 signals to seek from beginning of file
    fread(&byte,sizeof(byte),1,fp);
      //printf("byte:%i ",byte);
    NoBytes--;
  }
  UINT8 mask=128>>(NoBits-1);
  INT8 bit=((mask & byte) > 0);
  //printf("%i",bit);
  NoBits--;
  if ((NoBits==0)&&(NoBytes>0)) NoBits=8;//also triggers read of new byte
  else if ((NoBits==0)&&(NoBytes==0)) { //close the file stream
    printf("Closing file.");
    fclose(fp);fp=NULL;
  }
  //printf("NoBytes:%i ",NoBytes);
  //printf("(1):%i",bit);
  return bit;
}
//http://www.cprogramming.com/tutorial/cfileio.html
INT8 ReadBit2() {// file is read in the reversed order !
  static int NoBytes;// no of bytes left to read  
  static INT8 NoBits;// no of bits left to read
  static INT8 byte;// bits are read from this byte 
  INT8 ReadIncomplete=0;// signals if the last incomplete byte
  //should be read
  static FILE *fp=NULL;
  if (fp==NULL) {// init: get no. of bytes/bits
    fp=InitReadBit2(NULL);// get the file pointer
    while (1) {// estimate total no of bytes in the file
      fread(&byte,sizeof(byte),1,fp);//traverse all bytes
      if (feof(fp)) break;//until the last byte
      NoBytes++;//finally also includes signaling byte
    } 
    NoBytes-=1;// subtract last (non-binary) signaling byte
    NoBits=byte;//get the NoBits from the (last) signaling byte
    printf("ReadBit2():NoBytes:%i NoBits in last byte:%i\n",NoBytes,NoBits);
    if (NoBits!=8) ReadIncomplete=1;//the last bin byte is incomplete
  } // end of init
  if ((NoBits==8)||ReadIncomplete) {// read a new byte:
    //printf(" ");
    fseek(fp,NoBytes-1,0);// 0 signals to seek from beginning of file
    fread(&byte,sizeof(byte),1,fp);
      //printf("byte:%i ",byte);
    NoBytes--;
  }
  UINT8 mask=128>>(NoBits-1);
  INT8 bit=((mask & byte) > 0);
  //printf("%i",bit);
  NoBits--;
  if ((NoBits==0)&&(NoBytes>0)) NoBits=8;//also triggers read of new byte
  else if ((NoBits==0)&&(NoBytes==0)) { //close the file stream
    printf("Closing file.");
    fclose(fp);fp=NULL;
  }
  //printf("NoBytes:%i ",NoBytes);
  //printf("(2):%i",bit);
  return bit;
}
//http://www.cprogramming.com/tutorial/cfileio.html
